name: {{ inventory_hostname }}

# input configuration
filebeat:
  inputs:
    - type: log
      paths:
        - '/var/log/syslog'
        - '/var/log/*.log'
      processors:
      - add_fields:
          target: ''
          fields:
{% for field in logging_filebeat_add_fields %}
            {{ field.name }}: {{ field.value }}
{% endfor %}
            ska.application: syslog
    - type: journald
      id: everything
      paths: []
      seek: tail
      processors:
      - add_fields:
          target: ''
          fields:
{% for field in logging_filebeat_add_fields %}
            {{ field.name }}: {{ field.value }}
{% endfor %}
            ska.application: journald
{% if logging_filebeat_kubernetes_enabled|bool %}
    - type: container
      symlinks: true
      kube_config: /kube_config
      paths:
        - /var/log/containers/*.log
      exclude_files: ['\.gz$']
      exclude_lines: ["^\\s+[\\-`('.|_]"]  # drop asciiart lines
      multiline.type: pattern
# if the message start with "PyTango.DevFailed: DevFailed" or "DevError" or "Traceback" # or "severity" or 
# " " or "]" or the line is empty then it is considered multiline and will be attached to the previous line 
# that does not match. The "parsers" option indicated in the documentation does not work. 
      multiline.pattern: '^PyTango.DevFailed: DevFailed|^DevError|^Traceback|^severity|^[[:space:]]|^\]|^$'
      multiline.negate: false
      multiline.match: after
      processors:
      - add_kubernetes_metadata:
          kube_config: /kube_config
          host: {{ inventory_hostname }}
          default_matchers.enabled: false
          matchers:
          - logs_path:
              logs_path: "/var/log/containers/"
# get rid of all fluentd related logs
      - drop_event:
          when:
            or:
              - equals:
                  kubernetes.container.name: fluentd
              - equals:
                  container.labels.io_kubernetes_container_name: fluentd
              - regexp:
                  kubernetes.pod.name: "fluentd"
      - add_fields:
          target: ''
          fields:
{% for field in logging_filebeat_add_fields %}
            {{ field.name }}: {{ field.value }}
{% endfor %}
            ska.application: kubernetes
{% endif %}
{% if logging_filebeat_docker_enabled|bool %}
    - type: container
      combine_partial: true
      exclude_files: ['\.gz$']
      exclude_lines: ["^\\s+[\\-`('.|_]"]  # drop asciiart lines
      stream: all
      paths: ["/var/lib/docker/containers/*/*.log"]
      processors:
      - add_docker_metadata:
          host: "unix:///var/run/docker.sock"
# get rid of all filebeat/journalbeat related logs
      - drop_event:
          when:
              and:
                - equals:
                    container.name: {{ logging_filebeat_name }}
      - add_fields:
          target: ''
          fields:
{% for field in logging_filebeat_add_fields %}
            {{ field.name }}: {{ field.value }}
{% endfor %}
            ska.application: docker
{% endif %}
{% if logging_filebeat_podman_enabled|bool %}
    - type: container
      combine_partial: true
      exclude_files: ['\.gz$']
      exclude_lines: ["^\\s+[\\-`('.|_]"]  # drop asciiart lines
      stream: all
      paths: ["/var/lib/containers/storage/overlay-containers/*/*/*.log"]
      processors:
      - add_docker_metadata:
          match_source_index: 5
          host: "unix:///var/run/podman/podman.sock"
# get rid of all filebeat/journalbeat related logs
      - drop_event:
          when:
              and:
                - equals:
                    container.name: {{ logging_filebeat_name }}
      - add_fields:
          target: ''
          fields:
{% for field in logging_filebeat_add_fields %}
            {{ field.name }}: {{ field.value }}
{% endfor %}
            ska.application: podman
{% endif %}

# output configuration
output:
  elasticsearch:
    hosts: ["{{ logging_filebeat_elasticsearch_url }}"]
{% if logging_filebeat_http_authentication_required %}
    ssl.certificate_authorities: ["/etc/ca-certificate.crt"]
    ssl.certificate: "/etc/{{ logging_filebeat_certificate_name }}.crt"
    ssl.key: "/etc/{{ logging_filebeat_certificate_name }}.key"
{% else %}
    ssl.ca_trusted_fingerprint: "{{ logging_filebeat_ca_fingerprint }}"
{% endif %}
{% if logging_filebeat_elasticsearch_auth_method == "api-key" %}
    api_key: "{{ logging_filebeat_elasticsearch_password }}"
{% else %}
    username: "{{ logging_filebeat_elasticsearch_user }}"
    password: "{{ logging_filebeat_elasticsearch_password }}"
{% endif %}
    loadbalance: true
    worker: 1
{% if logging_filebeat_pipeline_enabled|bool %}
    pipeline: {{ logging_filebeat_pipeline_name }}
{% endif %}

{% if not logging_filebeat_queue_disk_enabled|bool %}
# queue memory configuration
queue.mem:
  events: "{{ logging_filebeat_queue_mem_events }}"
  flush.min_events: "{{ logging_filebeat_queue_mem_flush_min_events }}"
  flush.timeout: "{{ logging_filebeat_queue_mem_flush_timeout }}"
{% endif %}
{% if logging_filebeat_queue_disk_enabled|bool %}
# queue disk configuration
queue.disk:
  max_size: "{{ logging_filebeat_queue_disk_max_size }}"
{% endif %}

# ilm configuration
# https://www.elastic.co/guide/en/beats/filebeat/master/ilm.html#setup-ilm-check_exists-option
setup.ilm.enabled: true
setup.ilm.rollover_alias: "filebeat-%{[agent.version]}"
setup.ilm.pattern: "{now/d}-000001"
setup.ilm.check_exists: true
setup.ilm.overwrite: false
setup.ilm.policy_name: "filebeat"
setup.ilm.policy_file: /etc/filebeat-ilm-policy.json

# template configuration
setup.template.name: "filebeat-%{[agent.version]}"
setup.template.pattern: "filebeat-%{[agent.version]}"
setup.template.enabled: true
setup.template.overwrite: false
{% if logging_filebeat_pipeline_enabled|bool %}
setup.template.settings:
  index.default_pipeline: "{{ logging_filebeat_pipeline_name }}"
{% endif %}
setup.template.append_fields:
- name: ska_function
  type: text
  multi_fields:
    - type: keyword
      name: keyword
- name: ska_line_loc
  type: text
  multi_fields:
    - type: keyword
      name: keyword
- name: ska_log_message
  type: text
  multi_fields:
    - type: keyword
      name: keyword
- name: ska_log_timestamp
  type: date
- name: ska_severity
  type: text
  multi_fields:
    - type: keyword
      name: keyword
- name: ska_tags
  type: text
  multi_fields:
    - type: keyword
      name: keyword
- name: ska_thread_id
  type: text
  multi_fields:
    - type: keyword
      name: keyword
- name: ska_version
  type: text
  multi_fields:
    - type: keyword
      name: keyword
- name: ska_transaction_id
  type: text
  multi_fields:
    - type: keyword
      name: keyword
